;===============================================================================
;
; rage expansion 1.0
;
;===============================================================================
header
hirom

;===============================================================================
;
; link to choose command from control list
;
;===============================================================================
org     $C20600

;-------------------------------------------------------------------------------
; get random action from control list
;-------------------------------------------------------------------------------
rage_command_link:

    ;get random action from control list
        JSL rage_command

    ;continue
        JMP $060D

;-------------------------------------------------------------------------------
; get random number
;-------------------------------------------------------------------------------
random_number:

    ;get random number
        JSR $4B5A                   ;random number: [0, 255]

    ;exit
        RTL

warnpc  $C2060D

;===============================================================================
;
; get random command from control list
;
;===============================================================================
org     $C3FE00
rage_command:

    ;backup
        PHX                         ;backup X
        PHY                         ;backup Y
        PHP                         ;backup status

    ;get control list index
        REP #$30                    ;2AB mode, 2XY mode
        LDA $33A8,Y                 ;monster ID
        ASL
        ASL
        TAX                         ;X = monster control list offset
        SEP #$20                    ;1AB mode
        LDA $CF3D00,X               ;first action from control list
        PHA                         ;save it

    ;init loop
        TDC                         ;null AB
        TAY                         ;Y = first slot

    ;search
    .loop
        PHX                         ;backup X
        TYX                         ;get chance slot
        JSL random_number           ;get random number
        CMP.l chance_table,X        ;compare with table
        PLX                         ;restore action slot
        BCS .next                   ;skip if not in chance
        LDA $CF3D00,X               ;action from control list
        CMP #$FF                    ;empty command
        BEQ .next                   ;skip if empty command
        STA $01,S                   ;save command
    .next
        INX                         ;get next command slot
        INY                         ;get next chance slot
        CPY #$0004                  ;max number of slots
        BNE .loop

    ;check obtained action
        PLA                         ;get action
        CMP #$FF                    ;empty action
        BNE .exit                   ;skip if action is valid
        LDA #$EE                    ;setup fight command if action is invalid

    ;exit
    .exit
        PLP
        PLY
        PLX
        RTL
    
;-------------------------------------------------------------------------------
; chance table
;-------------------------------------------------------------------------------
chance_table:
    
    db #$FF, #$80, #$55, #$40

warnpc $C3FE41

